/*
 *  Lww.h - Public Definitions for Lww widget
 *
 */

#ifndef _Lww_h
#define _Lww_h

#include <X11/Xaw/Simple.h>

/***************************************************************************
 *
 * Lww Widget
 *
 **************************************************************************/

/* Parameters:

 Name                Class              RepType         Default Value
 ----                -----              -------         -------------
 foreground          Foreground         Pixel           XtDefaultForeground
 border              BorderColor        Pixel           XtDefaultForeground
 borderWidth         BorderWidth        Dimension       0
 callback            Callback           Pointer         LwwAction
 cursor              Cursor             Cursor          None
 cursorName          Cursor             String          NULL
 destroyCallback     Callback           Pointer         NULL
 height              Height             Dimension       8
 mappedWhenManaged   MappedWhenManaged  Boolean         True
 pointerColor        Foreground         Pixel           XtDefaultForeground
 pointerColorBackground Background      Pixel           XtDefaultBackground
 sensitive           Sensitive          Boolean         True
 width               Width              Dimension       8
 x                   Position           Position        0
 y                   Position           Position        0

*/

#define XtNlwwTranslations "lwwTranslations"


typedef struct LwwCallData {
  XEvent *event;                /* the event causing the LwwAction */
  String *params;               /* the TranslationTable params */
  Cardinal num_params;          /* count of params */
} LwwCallDataRec, *LwwCallData;

/* Class Record Constant */

extern WidgetClass lwwWidgetClass;

typedef struct _LwwClassRec *LwwWidgetClass;
typedef struct _LwwRec      *LwwWidget;

#endif /* _Lww_h */
