#include <stdio.h>
#include <stdlib.h>

typedef struct {
    int level;
    int cval;
} levelmap_t;

levelmap_t A[] = {
    {1L<<0  ,   0x00},
    {1L<<1  ,   0x11},
    {1L<<2  ,   0x22},
    {1L<<3  ,   0x33},
    {1L<<4  ,   0x44},
    {1L<<5  ,   0x55},
    {1L<<6  ,   0x66},
    {1L<<7  ,   0x77},
    {1L<<8  ,   0x88},
    {1L<<9  ,   0x99},
    {1L<<10 ,   0xaa},
    {1L<<11 ,   0xbb},
    {1L<<12 ,   0xcc},
    {1L<<13 ,   0xdd},
    {1L<<14 ,   0xee},
    {-1,        0xff},
};

levelmap_t B[] = {
    {1L<<0  ,   0xff},
    {1L<<1  ,   0xee},
    {1L<<2  ,   0xdd},
    {1L<<3  ,   0xcc},
    {1L<<4  ,   0xbb},
    {1L<<5  ,   0xaa},
    {1L<<6  ,   0x99},
    {1L<<7  ,   0x88},
    {1L<<8  ,   0x77},
    {1L<<9  ,   0x66},
    {1L<<10 ,   0x55},
    {1L<<11 ,   0x44},
    {1L<<12 ,   0x33},
    {1L<<13 ,   0x22},
    {1L<<14 ,   0x11},
    {-1,        0x00},
};

int
resolve_cval(levelmap_t *m, int l)
{
    int i;
    int r;

    i = 0;
    while(m[i].level>0 && l>m[i].level) {
        i++;
    }

    r = m[i].cval;

    return r;
}

main()
{
    int i;
    int v;
    int c;

    for(i=0;i<sizeof(A)/sizeof(levelmap_t);i++) {
        printf("%3d: %7d %3x\n", i, A[i].level, A[i].cval);
    }

    for(i=0;i<100;i++) {
#if 0
        v = lrand48()%(256*256*3);
#endif
        v = (lrand48()%256)*(lrand48()%256)
            + (lrand48()%256)*(lrand48()%256)
            + (lrand48()%256)*(lrand48()%256);

        c = resolve_cval(B, v);
        printf("%3d %7d -> %2x\n", i, v, c);
    }


}

