/*
 * alist.c - association list
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#ifdef TIME_WITH_SYS_TIME
 #include <sys/time.h>
 #include <time.h>
#else
 #ifdef HAVE_SYS_TIME_H
  #include <sys/time.h>
 #else
  #include <time.h>
 #endif
#endif
#include <errno.h>

#include "alist.h"
#include "sentry.h"

apair_t req_type_alist[] = {
    {"IAmAlive",    I_AM_ALIVE},
    {"OpenUDPuni",  OPEN_UDP_UNICAST},
    {"OpenUDPmulti",OPEN_UDP_MULTICAST},
    {"OpenTCP",     OPEN_TCP},
    {"Close",       CLOSE},
    {NULL,          -1},
};

apair_t req_attr_alist[] = {
    {"Size",        QOS_REQUEST_SIZE},
    {"Zoom",        QOS_REQUEST_ZOOM},
    {"Color",       QOS_REQUEST_COLOR},
    {"Format",      QOS_REQUEST_FORMAT},
    {"Rate",        QOS_REQUEST_RATE},
    {NULL,          -1},
};

apair_t format_alist[] = {
    {"None",        SEN_F_NONE},
    {"JPEG",        SEN_F_JPEG},
    {"JPG",         SEN_F_JPEG},
    {"PNG",         SEN_F_PNG},
    {"RGB",         SEN_F_RGB},
    {NULL,          -1},
};

apair_t color_alist[] = {
    {"None",        SEN_C_NONE},
    {"FullColor",   FULL_COLOR},
    {"GrayScale",   MONOCHROME},
    {"Gray",        SEN_C_GRAY},
    {"Grey",        SEN_C_GRAY},
    {"RGB",         SEN_C_RGB},
    {"BGR",         SEN_C_BGR},
    {"XRGB",        SEN_C_XRGB},
    {"RGBX",        SEN_C_RGBX},
    {"RGBA",        SEN_C_RGBA},
    {"XBGR",        SEN_C_XBGR},
    {"RGBX",        SEN_C_BGRX},
    {"BGRA",        SEN_C_BGRA},
    {NULL,          -1},
};

apair_t anchor_alist[] = {
    {"LeftTop",     SEN_A_LT},
    {"Left",        SEN_A_L},
    {"LeftBottom",  SEN_A_LB},
    {"Top",         SEN_A_T},
    {"Center",      SEN_A_C},
    {"Bottom",      SEN_A_B},
    {"RightTop",    SEN_A_RT},
    {"Right",       SEN_A_R},
    {"RightBottom", SEN_A_RB},
    {NULL,          -1},
};

apair_t size_alist[] = {
    {"unknown",     SIZE_UNKNOWN},

    {"640x480n",    SIZE_640x480},
    {"640x480",     SIZE_640x480},
    {"320x240n",    SIZE_320x240},
    {"320x240",     SIZE_320x240},
    {"212x160n",    SIZE_212x160},
    {"212x160",     SIZE_212x160},
    {"160x120n",    SIZE_160x120},
    {"160x120",     SIZE_160x120},

    {"640x360w",    SIZE_640x360},
    {"640x360",     SIZE_640x360},
    {"320x180w",    SIZE_320x180},
    {"320x180",     SIZE_320x180},
    {"212x120w",    SIZE_212x120},
    {"212x120",     SIZE_212x120},
    {"160x90w",     SIZE_160x90},
    {"160x90",      SIZE_160x90},

    {NULL,          -1},
};

apair_t req_desc_alist[] = {
    {size_alist,    QOS_REQUEST_SIZE},
    {color_alist,   QOS_REQUEST_COLOR},
    {format_alist,  QOS_REQUEST_FORMAT},
    {NULL,          -1},
};

apair_t buflen_xrgb_alist[] = {

    {(char*)(640*480*4),    SIZE_640x480},
    {(char*)(320*240*4),    SIZE_320x240},
    {(char*)(212*160*4),    SIZE_212x160},
    {(char*)(160*120*4),    SIZE_160x120},
    
    {NULL,          -1},
};

