/*
 * client.h - client common 
 *
 */
#ifndef _SENTRY_CLIENT_H_
#define _SENTRY_CLIENT_H_

#ifndef SIGPOLL
#define SIGPOLL         SIGIO
#endif

#ifndef INADDR_NONE
#define INADDR_NONE     0xffffff
#endif

#ifndef MAX
#define MAX(x,y)        ((x)>(y) ? (x) : (y))
#endif

#ifndef DEFAULT_RATE
#define DEFAULT_RATE    (200)
#endif

#ifndef MAX_DISPLAY_SIZE
#define MAX_DISPLAY_SIZE    SIZE_320x240
#endif


/*
 * functions
 */
/* sentryc.c */


/* shm.c */
int     dump_shm_content;
void dump_shm_(char *path);
/*
 * sentryc -- default configuration parameter
 */

/* sentryc parameter */
#ifndef REQUEST_INTERVAL 
#define REQUEST_INTERVAL        (10)
#endif

#define SHM_SIZE            (50)
#define LOCKFILE            "/tmp/sentryc.pid"
#define WAIT_TIME           (3)
#define RATEVIEW_INTERVAL   (5)     /* in sec */

extern int      shm_size;
extern int      save_type;

extern int      wait_time;

extern int      request_interval;
extern int      rateview_interval;


extern  char server_host[];
extern int      server_port;
extern u_char   client_type;
extern int      server_size;
extern int      server_zoom;
extern int      server_color;
extern int      server_format;
extern int      server_rate;
extern int      hivision_flag;
extern int      voffset;

extern  int use_shm_flag;
extern  int debug;
extern  int verbose;
extern  int report_interval;

extern  int output_format;
extern  int output_corder;

extern  int ctrlfd;
extern  int datafd;
extern  int data_port;


void complete();
int build_ctrl_port(char*, int);
int build_data_port(int);
void init_request();
void reqeust_call();

/*
int new_udp_socket();
*/

int get_data2(int, char**, sentry_shmrec*, sentry_shmrec*);
int recv_image(int, char**, sentry_shmrec*, sentry_imgrec*);


#endif /*  _SENTRY_CLIENT_H_ */

