/*==
 ==*/

/*
 * cmd.c - command 
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif /* HAVE_CONFIG_H */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif

#include <errno.h>



int
_split_word(char *line, char *cmd, char *rest, int cap)
{
    register char *p, *q;
    register int c;

    p = line;
    q = cmd;
    c = 0;
    while(*p && c<BUFSIZ) {
        if(*p==' '|| *p=='\t' || *p=='\r' || *p=='\n') {
            break;
        }
        *q++ = *p++;
        c++;
    }
    *q = '\0';

    while(*p==' ' || *p=='\t') {
        p++;
    }

    q = rest;
    c = 0;
    while(*p && c<BUFSIZ) {
        if(*p=='\r' || *p=='\n') {
            break;
        }
        *q++ = *p++;
        c++;
    }
    *q = '\0';

    if(cap) {
        p = cmd;
        while(*p) {
            *p = toupper(*p);
            p++;
        }
    }

#if 0
    printf("split_cmd %s-> '%s' '%s'\n", line, cmd, rest);
#endif

    return 0;
}

int
split_word(char *line, char *cmd, char *rest)
{
    return _split_word(line, cmd, rest, 0);
}

int
split_cmd(char *line, char *cmd, char *rest)
{
    return _split_word(line, cmd, rest, 1);
}


extern int debug;

char*
split_arg4(char *line, char *a1, char *a2, char *a3, char *a4)
{
    char *p, *q;
    int c;

    a1[0] = a2[0] = a3[0] = a4[0] = '\0';

    p = line;
    while(*p==' '||*p=='\t') {
        p++;
    }
#if 1
    c = 0;
    q = p;
    while(*q && c<BUFSIZ) {
        if(*q=='\r'||*q=='\n') {
            *q = '\0';
            break;
        }
        q++;
        c++;
    }
#endif

    c = 0;
    q = a1;
    while((*p && c<BUFSIZ) && *p!=' ' && *p!='\t') {
        *q++ = *p++;
        c++;
    }
    *q = '\0';
    while(*p==' '||*p=='\t') {
        p++;
    }

    c = 0;
    q = a2;
    while((*p && c<BUFSIZ) && *p!=' ' && *p!='\t') {
        *q++ = *p++;
        c++;
    }
    *q = '\0';
    while(*p==' '||*p=='\t') {
        p++;
    }

    c = 0;
    q = a3;
    while((*p && c<BUFSIZ) && *p!=' ' && *p!='\t') {
        *q++ = *p++;
        c++;
    }
    *q = '\0';
    while(*p==' '||*p=='\t') {
        p++;
    }

    c = 0;
    q = a4;
    while(*p && c<BUFSIZ) {
        *q++ = *p++;
        c++;
    }
    *q = '\0';


#if 1
    if(debug>20) {
        fprintf(stderr, "[%s] -> '%s' '%s' '%s' '%s'\n",
            line, a1, a2, a3, a4);
    }
#endif

    return a1;
}


int
get_cmdline(int ifd, char *lbuf)
{
static int  xbsum = 0;
static char xbuf[BUFSIZ*2] = "";
    char *p, *q, *en;
    int nread;
    int c;

#if 0
    fprintf(stderr, "xbuf b [%s] %d\n", xbuf, xbsum);
#endif
    if(xbsum>=BUFSIZ) { 
        fprintf(stderr, "no space in buffer\n");
        return -1;
    }
    nread = read(ifd, &xbuf[xbsum], BUFSIZ-1);
    if(nread<0) {
        fprintf(stderr, "fail read (%d)\n", errno);
        return -1;
    }
    if(nread==0) {
        fprintf(stderr, "reach to end\n");
        return 0;
    }

    xbsum += nread;
    xbuf[xbsum] = '\0';
#if 0
    fprintf(stderr, "xbuf m [%s]\n", xbuf);
#endif

    en = &xbuf[BUFSIZ*2];

    p = &xbuf[0];
    q = lbuf;
    c = 0;
    while(*p && c<BUFSIZ && *p!='\r' && *p!='\n') {
        *q++ = *p++;
        c++;
    }
    *q = '\0';
    while(*p && (*p=='\r'||*p=='\n')) {
        p++;
    }
#if 0
    fprintf(stderr, "p %p, &xbuf[0] %x, c %d\n", p, &xbuf[0], c);
#endif
    memmove(p, &xbuf[0], en-p);
    xbsum -= (p - &xbuf[0]);
    xbuf[xbsum] = '\0';
    
#if 0
    fprintf(stderr, "lbuf - [%s]\n", lbuf);
    fprintf(stderr, "xbuf a [%s] %d\n", xbuf, xbsum);
#endif

#if 0
    return c;
#endif
    return 1;
}
