/*
 * fig.h
 *
 * $Id$
 */

#ifndef FIG_H
#define FIG_H

/* see also, object.h in 'xfig'-package */


#define FIG_VERSION_3_1     300100
#define FIG_VERSION_3_2     300200

#define FIG_UNKNOW      -1
#define FIG_COLOR       0
#define FIG_ELLIPSE     1
#define FIG_POLYLINE    2
#define FIG_SPLINE      3
#define FIG_TEXT        4
#define FIG_ARC         5
#define FIG_COMPOUND    6
#define FIG_UNDEF       7

#define FIG_SOLID_LINE          0
#define FIG_DASH_LINE           1
#define FIG_DOTTED_LINE         2
#define FIG_DASH_DOT_LINE       3
#define FIG_DASH_2_DOTS_LINE    4
#define FIG_DASH_3_DOTS_LINE    5


extern apair_t figtype_alist[];

/*
 *
 */

typedef struct {
    int x, y;
} fig_pos;

typedef struct {
    float x, y;
} fig_fpos;

typedef struct {
    int type;
    int style;
    float thickness;
    float width;
    float height;
} fig_arrow;


/*
 *
 */

typedef struct {
    int objtype;
    int cnum;
    int value;
} fig_color_t;

typedef struct {
    int objtype;
    int depth;
    fig_fpos center;
} fig_arc_t;

typedef struct {
    int objtype;
    int depth;
    int subtype;
    int style;
    int thickness;

    int pen_color;
    int fill_color;
    int area_fill;

    fig_arrow *for_arrow;
    fig_arrow *back_arrow;
    int npoints;
    fig_pos *points;
    int     radius;
} fig_line_t;

typedef struct {
    int objtype;
    int depth;
    int subtype;
    int style;
    int thickness;

    int pen_color;
    int fill_color;
    int area_fill;

    fig_arrow *for_arrow;
    fig_arrow *back_arrow;
    int npoints;
    fig_pos *points;
    int     radius;
} fig_spline_t;

typedef struct {
    int objtype;
    int depth;
    int subtype;
    int style;
    int thickness;

    int pen_color;
    int fill_color;
    int area_fill;

    fig_pos center;
    fig_pos radiuses;
    fig_pos start;
    fig_pos end;
} fig_ellipse_t;

typedef struct {
    int objtype;
    int depth;
    int subtype;
    int thickness;
    int color;
    int font;
    float angle;
    float font_size;
    int font_flags;
    float height;
    float length;
    fig_pos pos;
    char *value;
} fig_text_t;



/* XXX */
#define FIG_OBJTYPE(x)      (*((int*)(x)) )

extern char *_fig_obj_type_str[];
#define FIG_OBJTYPESTR(x)   \
  ((x)<FIG_COLOR ? _fig_obj_type_str[FIG_UNDEF] : \
    ((x)>FIG_COMPOUND ? _fig_obj_type_str[FIG_UNDEF] : _fig_obj_type_str[(x)]))

/*
 *
 */
typedef struct _fig_list {
    void *cont;
    int len;
    struct _fig_list *next;
} fig_list_t;

typedef struct {
    int max;
    int len;
    int *book;
} fig_cnbook_t;

typedef struct {
    int ulx, uly, lrx, lry;
    fig_cnbook_t *cnbook;
    int lslen;
    void *lsbook;
    fig_list_t *list;
} xp_fig_elem_t;


void show_fig_object(void *);
xp_fig_elem_t *read_fig_fp(FILE*);
xp_fig_elem_t *read_fig_file(char*);


#endif /* FIG_H */
