/*
 * $Id: hook.h,v 1.1 1998/02/27 14:31:30 k-chinen Exp k-chinen $
 */

#ifndef _HOOK_H_
#define _HOOK_H_


#ifndef DEFAULT_TRACE_FLAG_VALUE
#define DEFAULT_TRACE_FLAG_VALUE 0
#endif


/* default value (0 is off, 1 in on) */
static int _trace_flag_ = DEFAULT_TRACE_FLAG_VALUE; 


#ifndef Trace
#define Trace   if(_trace_flag_) printf
#endif

#ifndef Error
#define Error   printf
#endif


#define TraceOn     _trace_flag_ = 1
#define TraceOff    _trace_flag_ = 0
#define TraceRev    _trace_flag_ = 1 - _trace_flag_
#define TracePush   _trace_flag_++
#define TracePop    fflush(stdout); --_trace_flag_



#ifdef MEMCHECK
void enter_memorydebug_mode();
void show_memoryusage();
void show_memoryusage_long();
#endif
void *malloc(size_t);
void free(void*);


#ifdef MEMCHECK
#define MEMORY_TRAP(x) \
    { \
        TracePush; \
        Trace(x); \
        show_memoryusage(); \
        Trace("\n"); \
        fflush(stdout); \
        fflush(stderr); \
        TracePop; \
    }
#else
#define MEMORY_TRAP(x)
#endif



#ifndef MALLOC
#if 1
#define MALLOC(x)   malloc(x)
#else
#define MALLOC(x)   (_trace_flag_ ? printf("CALL malloc() %s:%d\n", __FILE__, __LINE__) : 0, malloc(x))
#endif
#endif

#ifndef FREE
#if 0
#define FREE(x) free(x)
#else
#define FREE(x) Trace("CALL free(%p) %s:%d\n", x, __FILE__, __LINE__); free(x)
#endif
#endif



#ifndef STRDUP
#define STRDUP(x)   strdup(x)
#endif


#endif /* _HOOK_H_ */
