/*
 * img.h
 */

#ifndef _SENTY_IMG_H_
#define _SENTY_IMG_H_

#ifdef HAVE_INTTYPES_H
#include <inttypes.h>
#endif

#define SEN_M_NONE      (0x00)
#define SEN_M_TATTR     (0x11)
#define SEN_M_IATTR     (0x12)
#define SEN_M_1POINT    (0x21)
#define SEN_M_4POINTS   (0x24)
#define SEN_M_9POINTS   (0x29)
#define SEN_M_ALL       (0x2F)

extern apair_t matching_type_alist[];

/* NOTE:
 *  old clients expect first and second word(32bit) are timestamp and length
 */


typedef struct {
    int     length;
    time_t  send_sec;        /* issued date, server said */
    time_t  send_usec;
    time_t  recv_sec;        /* received date, i got */
    time_t  recv_usec;
    int     format;
    int     corder;
    int     width;
    int     height;
    int     body_len;       /* hom many length is allocated */
    uint8_t *body;
} sentry_imgrec3;

typedef struct {
    time_t  send_sec;        /* issued date, server said */
    int     length;
    time_t  send_usec;
    time_t  recv_sec;        /* received date, i got */
    time_t  recv_usec;
    int     format;
    int     corder;
    int     width;
    int     height;
    int     body_len;       /* hom many length is allocated */
    uint8_t *body;
} sentry_imgrec2;

typedef sentry_imgrec3 sentry_imgrec;


int show_imgattr(FILE*, sentry_imgrec*);


#endif /* _SENTY_IMG_H_ */
