/*==
 ==*/
/*
 $Id$
*/
/*
 * nv - node viewer
 */

#ifndef _NV_H_
#define _NV_H_

#define RM_QUERY_PORT     (2236)
#define COMM_SITTER_PORT  (8765)

#define PROGNAME_MAX        (64)
#ifndef MAX_LOWERNODE
#define MAX_LOWERNODE       (10)
#endif

#define NV_T_NONE       (0x0000)
#define NV_T_CAMERA     (0x0001)
#define NV_T_VIEWER     (0x0002)
#define NV_T_FILTER     (0x0011)
#define NV_T_SCANNER    (0x0012)


#ifndef MAX_VIEWER
#define MAX_VIEWER (10)
#endif


typedef struct _node_t {
    int  id;

    int   type;
    char  *name;
    char  *host;
    time_t ctime;

    char  prog_name[PROGNAME_MAX];

    int   sitter_port;
    int   sitter_fd;
    int   down_listen_port;
    char  *dlcid;
    int   up_recv_port;

    int   filtermode;

    void *prop;
    char *desc;

    int  x;
    int  y;
    int  hidle;

    struct _node_t *unid[MAX_LOWERNODE];
    struct _node_t *lnid[MAX_LOWERNODE];
    char *ucid[MAX_LOWERNODE];
    char *lcid[MAX_LOWERNODE];
    struct _node_t *Hup[MAX_LOWERNODE];
    struct _node_t *Hlo[MAX_LOWERNODE];

    struct _node_t *next;
} node_t;


extern node_t *nodelist;
extern apair_t node_type_alist[];
extern apair_t node_type_c_alist[];

int start_allnodes(node_t *nd);

int v_start_request(node_t *this, int rfd);
int v_stop_request(node_t *this);


#endif /* _NV_H_ */


