
/*
 * pool.h
 */

#ifndef _POOL_H_
#define _POOL_H_


#ifdef SENTRY_SHM_MAGIC
#undef SENTRY_SHM_MAGIC
#endif /* SENTRY_SHM_MAGIC */
#define SENTRY_SHM_MAGIC    "SENTRY"

#ifdef SENTRY_SHM_VERSION
#undef SENTRY_SHM_VERSION
#endif /* SENTRY_SHM_VERSION */
#define SENTRY_SHM_VERSION  (3)


#ifndef SENTRY_SHMKEY
#define SENTRY_SHMKEY   (97812)
#endif /* SENTRY_SHMKEY */

#ifndef SENTRY_SHM_BLOCK_SIZE
#define SENTRY_SHM_BLOCK_SIZE   (16*1024)        /* 16 KB */
#endif /* SENTRY_SHM_BLOCK_SIZE */

#ifndef SENTRY_SHM_HEADER_SIZE
#define SENTRY_SHM_HEADER_SIZE  (64)
#endif /* SENTRY_SHM_HEADER_SIZE */

#ifndef SENTRY_SHM_CHUNK_RADIX
#define SENTRY_SHM_CHUNK_RADIX  (256)
#endif /* SENTRY_SHM_CHUNK_RADIX */

#ifdef __linux
  #define key __key
  #define seq __seq
#endif

typedef union {
  char _dummy[SENTRY_SHM_BLOCK_SIZE];

  struct {
    sentry_imgrec header;
    char _padding[SENTRY_SHM_HEADER_SIZE - sizeof(sentry_imgrec)];
    unsigned char body_area[SENTRY_SHM_BLOCK_SIZE - SENTRY_SHM_HEADER_SIZE];
  } entry;

  struct {
    char magick[16];
    char ver[16];
    time_t last_update;
    int radix;
  } info;
} sentry_shmrec;

#if 0
typedef union {
  char _dummy[SENTRY_SHM_BLOCK_SIZE];

  struct {
    union {
      char __dummy[64];
      struct {
        time_t  recv_sec;
        long    length;
        time_t  recv_usec;
        time_t  send_sec;
        time_t  send_usec;
        int     format;
        int     corder;
        int     width;
        int     height;
      } attr;
    } header;
    unsigned char body[SENTRY_SHM_BLOCK_SIZE-64];
  } entry;

  struct {
    char magick[16];
    char ver[16];
    time_t last_update;
    int radix;
  } info;
} sentry_imgrec;
#endif

extern int      pool_inited;

extern key_t    sentry_shmkey;
extern int      sentry_shmid;
extern int      sentry_shm_chunk_radix;

extern sentry_shmrec *sentry_shm_chunk;
extern sentry_shmrec *sentry_shm_info;


int make_new_pool (key_t shmkey, size_t pool_size);
int delete_pool (int shmid);
int assign_pool (key_t shmkey);    
int show_pool_stat (int shmid);

#endif /* _POOL_H_ */
