/*
 * Sentry Video System
 *
 * $Id: $
 */

/*
 * put_image.c - output image procedures
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif



#include <stdio.h>
#include <stdlib.h>
#ifdef TIME_WITH_SYS_TIME
 #include <sys/time.h>
 #include <time.h>
#else
 #ifdef HAVE_SYS_TIME_H
  #include <sys/time.h>
 #else
  #include <time.h>
 #endif
#endif
#include <errno.h>



#include <X11/Intrinsic.h>
#include <X11/Xlib.h>
#if 0
#include <Xm/XmAll.h>
#endif

#include "alist.h"
#include "sentry.h"

static XImage       *ximage = NULL;

extern int debug;

/*
extern XtAppContext app;
extern Window       camera_window;
extern char         *connection_host;
extern Widget image_shell;
extern int frame_per_sec;
*/

int client_zoom = 1;


/*
extern void print_message();
*/
#define print_message   printf




/*
extern Display      *display;
extern GC           gc;
extern Visual       *visual;
extern int          depth;
*/

/*
 * put_image
 */
void
put_image_xy(Display *display, Visual *visual, int depth, GC gc, Window window,
    int x, int y, int width, int height, char *data)
{
    char mesg[128];
    static int last_width, last_height;

#if 0
    if (debug >= 10)
        fprintf(stderr, "put_image_xy: data=%d/ ximage=%d [width#last=%d/cur=%d/ height#last=%d/cur=%d] client_zoom=%d\n",
            data, ximage, last_width, width*client_zoom,
            last_height, height*client_zoom, client_zoom);
#endif
#if 1
    if (debug >= 10)
        fprintf(stderr, "put_image_xy: data=%p wid %d/%d ht %d/%d\n\
  via dpy %p, vis %p, depth %d, gc %d, win %d\n\
  ximage %p\n",
            data, width, last_width, height, last_height,
            display, visual, depth, gc, window,
            ximage);
#endif


    if (ximage == NULL ||
        last_width != width*client_zoom || 
        last_height != height*client_zoom) {
        if(debug>=100)
            printf("put_image_xy: (%d x %d)\n",
                width*client_zoom, height*client_zoom);

        if (ximage != NULL)
            XDestroyImage(ximage);

        ximage = XCreateImage(display, visual, depth, ZPixmap, 0, 0,
            width*client_zoom, height*client_zoom, 
            BitmapPad(display), 0);
        if (debug)
            fprintf(stderr, "created ximage [addr=%p]\n", ximage);

        if (ximage == NULL) {
            fprintf(stderr, "XCreateImage() failed.\n");
            print_message("XCreateImage() failed.");
            return;
        }
    }
    ximage->data = data;

    last_width = width*client_zoom;
    last_height = height*client_zoom;

    XPutImage(display, window, gc, ximage, 
        0, 0, x, y, last_width, last_height);

/*
    frame_per_sec++;
*/

    if (debug >= 10) {
        fprintf(stderr, "put_image: XPutImage done.\n");
        /*
        save_image(width, height, data);
        */
    }

    XFlush(display);
}

void
put_image(Display *display, Visual *visual, int depth, GC gc, Window window,
    int width, int height, char *data)
{
    put_image_xy(display, visual, depth, gc, window,
        0, 0, width, height, data);
}
