/*==
 ==*/

/*
 * $Id$
 */
/*
 * to avoid copyright, this program use original digit font.
 */

#include <stdio.h>
#include <stdlib.h>

typedef struct {
    unsigned char c;
    unsigned char b[30];
} cbmap_t;

cbmap_t cbits[256];
cbmap_t predef[21] = {
 {'0',{1,1,0,0,1,1,0,1,1,0,1,0,1,0,0,1,0,0,1,0,1,0,1,1,0,1,1,0,0,1,},},
 {'1',{1,1,1,0,1,1,1,0,0,1,1,1,1,0,1,1,1,1,0,1,1,1,1,0,1,1,0,0,0,0,},},
 {'2',{1,0,0,0,1,1,1,1,1,0,1,1,1,0,0,1,1,0,1,1,1,0,1,1,1,1,0,0,0,0,},},
 {'3',{1,0,0,0,1,1,1,1,1,0,1,0,0,0,1,1,1,1,1,0,1,1,1,1,0,1,0,0,0,1,},},
 {'4',{1,0,1,0,1,1,0,1,0,1,1,0,1,0,1,1,0,0,0,0,1,1,1,0,1,1,1,1,0,1,},},
 {'5',{1,0,0,0,0,1,0,1,1,1,1,0,0,0,0,1,1,1,1,0,1,1,1,1,0,1,0,0,0,1,},},
 {'6',{1,1,0,0,0,1,0,1,1,1,1,0,0,0,0,1,0,1,1,0,1,0,1,1,0,1,1,0,0,1,},},
 {'7',{1,0,0,0,0,1,1,1,1,0,1,1,1,1,0,1,1,1,0,1,1,1,0,1,1,1,0,1,1,1,},},
 {'8',{1,1,0,0,1,1,0,1,1,0,1,1,0,0,1,1,0,1,1,0,1,0,1,1,0,1,1,0,0,1,},},
 {'9',{1,1,0,0,1,1,0,1,1,0,1,0,1,1,0,1,1,0,0,0,1,1,1,0,1,1,1,0,1,1,},},
 {':',{1,1,1,1,1,1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1,1,1,1,1,},},
 {':',{1,1,0,0,1,1,1,0,0,1,1,1,1,1,1,1,1,0,0,1,1,1,0,0,1,1,1,1,1,1,},},
 {'-',{1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,},},
 {'/',{1,1,1,1,1,1,1,1,1,0,1,1,1,0,1,1,1,0,1,1,1,0,1,1,1,1,1,1,1,1,},},
 {'_',{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,0,1,0,0,0,0,},},
 {'.',{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,0,0,1,1,},},
 {'x',{1,1,1,1,1,1,0,1,1,0,1,1,0,0,1,1,1,0,0,1,1,0,1,1,0,1,1,1,1,1,},},
 {'+',{1,1,1,1,1,1,1,1,1,1,1,1,0,1,1,1,0,0,0,1,1,1,0,1,1,1,1,1,1,1,},},
 {',',{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,1,1,1,1,0,1,1,1,1,0,1,1,},},
 {' ',{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,},},
 {'O',{1,0,0,0,0,1,0,1,1,0,1,0,1,1,0,1,0,1,1,0,1,0,1,1,0,1,0,0,0,0,},},
};

int cbits_initted=0;

int
cbits_init()
{
    int i;
    int k;
    int npre;

    if(cbits_initted) {
        return 0;
    }

    memset(cbits, 0, sizeof(cbits));
    for(i=0;i<256;i++) {
        cbits[i].c = i;
    }
    
    npre = sizeof(predef)/sizeof(cbmap_t);
    fprintf(stderr, "load %d letters\n", npre);
    for(i=0;i<npre;i++) {
        k = predef[i].c;
        memcpy(&(cbits[k].b[0]),&(predef[i].b[0]), 30);
#if 0
        fprintf(stderr, "copy ch# %d 0x%x\n", k, k);
#endif
    }

    cbits_initted++;
}

int
cbits_dumpchar(FILE *ofp, unsigned char xch)
{
    int x, y;
    int z;
    char tmp[BUFSIZ];
    char *p;

    fprintf(ofp, "char %d '%c'\n", xch, xch);
    for(y=0;y<6;y++) {
        p = tmp;
        for(x=0;x<5;x++) {
            z = y*5+x;
            if(cbits[xch].b[z])     { *p++ = ' ';}
            else                    { *p++ = 'x';}
        }
        *p = '\0';
        fprintf(ofp, "%s\n", tmp);
    }

}

int
cbits_dumpstr(FILE *ofp, unsigned char *st)
{
    int x, y;
    int z;
    int len;
    unsigned char xch;
    char tmp[BUFSIZ];
    char *p;
    char *u;
    
    len = strlen(st);
    if(len*5+1>BUFSIZ) {
        return -1;
    }

    fprintf(ofp, "string '%s'\n", st);
    for(y=0;y<6;y++) {
        p = tmp;
        u = st;
        while(*u) {
            xch = *u;
            for(x=0;x<5;x++) {
                z = y*5+x;
                if(cbits[xch].b[z])     { *p++ = ' ';}
                else                    { *p++ = 'x';}
            }
            u++;
        }
        *p = '\0';
        fprintf(ofp, "%s\n", tmp);
    }

}


/*
 * put letter at px, py in pix (width x height) with st.
 */
int
put_letter_rgb(unsigned char *pix, int wid, int ht, int en,
    int px, int py, unsigned char *st)
{
    int i;
    int x, y;
    int z;
    int len;
    char *u;
    FILE *ofp;
    unsigned char *bp;
    char fha[BUFSIZ], bha[BUFSIZ];

    ofp = stderr;

    cbits_init();
    
    len = strlen(st);
    if(len*5+1>BUFSIZ) {
        return -1;
    }

#if 0
    if(len>10) {
        strncpy(fha, st, 10);
        fha[10] = '\0';
        strcpy(bha, &st[10]);
        cbits_dumpstr(stderr, fha);
        cbits_dumpstr(stderr, bha);
    }
    else{
        cbits_dumpstr(stderr, st);
    }
#endif

#if 0
    fprintf(ofp, "size %dx%d, pos %d,%d\n", wid, ht, px, py);
    fprintf(ofp, "string '%s'\n", st);
#endif

    bp = &pix[(py*wid+px)*en];
    memset(bp, 0xff, (len*5+1)*en);
    bp = &pix[((py+7)*wid+px)*en];
    memset(bp, 0xff, (len*5+1)*en);

    for(y=0;y<6;y++) {
        u = st;
        i = 0;
        while(*u) {
            for(x=0;x<5;x++) {
                z = y*5+x;
                bp = &pix[((py+1+y)*wid+(px+i*5+x))*en];
                if(cbits[*u].b[z])  {
                    *bp++ = 0xff;
                    *bp++ = 0xff;
                    *bp++ = 0xff;
                }
                else {
                    *bp++ = 0x00;
                    *bp++ = 0x00;
                    *bp++ = 0x00;
                }
            }
            u++;
            i++;
        }

        bp = &pix[((py+1+y)*wid+px+len*5)*en];
        *bp++ = 0xff;
        *bp++ = 0xff;
        *bp++ = 0xff;
    }

    return 0;
}

#ifdef TEST_CBITS
main()
{
    cbits_init();

#if 0
    cbits_dumpchar(stdout, '0');
#endif
    cbits_dumpstr(stdout, "0123456789");
#if 0
    cbits_dumpstr(stdout, ":;<=>?@ABC");
#endif
    cbits_dumpstr(stdout, " 43  5-15 19:");
    cbits_dumpstr(stdout, "12/23 4:39am");
    cbits_dumpstr(stdout, "01:23:45.67");

}
#endif
