/*
 * $Id$
 */

#ifndef XP_STR_DRAW_H
#define XP_STR_DRAW_H


/*
 * primitives
 */

int _DrawString(Display *dpy, Window win, GC gc,
        int sx, int sy, Pixel fg, Pixel bg, int depth,
        char *afontname, char *kfontname, int csize,
        unsigned char *line, int exp_expand);

int _GetStringLength(Display *dpy,
      char *afontname, char *kfontname, int csize, unsigned char *line, int exp_expand);

int _GetStringNchar(Display *dpy,
      char *afontname, char *kfontname, int csize, unsigned char *line, int exp_expand, int qx);

int _GetStringXpos(Display *dpy,
      char *afontname, char *kfontname, int csize, unsigned char *line, int exp_expand, int qx);


#define DrawString(d, w, g, x, y, f, b, dp, ff, s, e) \
    _DrawString(d, w, g, x, y, f, b, dp, \
        (ff)->afont, (ff)->kfont, (int)(ff)->csize, s, e)

#define GetStringLength(d, ff, s, e) \
    _GetStringLength(d, (ff)->afont, (ff)->kfont, (int)(ff)->csize, s, e)

#define GetStringNchar(d, ff, s, e, q) \
    _GetStringNchar(d, (ff)->afont, (ff)->kfont, (int)(ff)->csize, s, e, q)

#define GetStringXpos(d, ff, s, e, q) \
    _GetStringXpos(d, (ff)->afont, (ff)->kfont, (int)(ff)->csize, s, e, q)


/*
 * complexd
 */

int
DrawSimpleFoldString(Display *dpy, Window win, GC xgc,
    int sx, int sy, Pixel fg, Pixel bg, int depth,
    int wx, int wy, int *rx, int *ry,
    xp_font_t *ft, char *origline,
    double iratio, double lratio, int opt);


int
DrawFancyFoldString(Display *dpy, Window win, GC xgc,
    int sx, int sy, Pixel fg, Pixel bg, int depth,
    int wx, int wy, int *rx, int *ry,
    xp_font_t *ft, char *origline,
    double iratio, double lratio, int opt);


#endif /* XP_STR_DRAW_H */


