#include <stdio.h>
#include <time.h>
#include <sys/time.h>

#define SUB_TIME(x,y) \
        ( (x.tv_sec  - y.tv_sec )*1000 + (x.tv_usec - y.tv_usec)/1000 )



int convert_RGB2XBGR(unsigned char *dest, unsigned char *src, int len);
int convert_RGB2BGRX(unsigned char *dest, unsigned char *src, int len);
int convert_none(char *cur, int size, int xsize, int ysize, int *nxsize, int *nysize, char **new);
void convert_BGRA2RGB_s(unsigned char *cur, int xsize, int ysize);
void convert_BGR2RGB_s(unsigned char *cur, int xsize, int ysize);
int sub_rgb(unsigned char *abuf, unsigned char *bbuf, unsigned char *cbuf, int wid, int ht);
int sub_bgrx(unsigned char *abuf, unsigned char *bbuf, unsigned char *cbuf, int wid, int ht);
int engray_rgb(unsigned char *dst, unsigned char *src, int wid, int ht, int el);
int flip_rgb(unsigned char *dst, unsigned char *src, int wid, int ht, int el);
int flop_rgb(unsigned char *dst, unsigned char *src, int wid, int ht, int el);
int sub3hc_rgb(unsigned char *dst, unsigned char *src1, unsigned char *src2, int wid, int ht, int el);
int sub3_rgb(unsigned char *dst, unsigned char *src1, unsigned char *src2, int wid, int ht, int el);
int hline_rgb(unsigned char *dst, unsigned char *src, int wid, int ht, int el);
int vline_rgb(unsigned char *dst, unsigned char *src, int wid, int ht, int el);
int hvline_rgb(unsigned char *dst, unsigned char *src, int wid, int ht, int el);
int brightcircle_rgb(unsigned char *dst, unsigned char *src, int wid, int ht, int el, int rr);
int clipcircle_rgb(unsigned char *dst, unsigned char *src, int wid, int ht, int el, int rr);
int dope_rgb(unsigned char *dst, unsigned char *src, int wid, int ht, int el);
int add3_rgb(unsigned char *dst, unsigned char *src1, unsigned char *src2, int wid, int ht, int el);
int Xadd3_rgb(unsigned char *dst, unsigned char *src1, unsigned char *src2, int wid, int ht, int el);
int mul3_rgb(unsigned char *dst, unsigned char *src1, unsigned char *src2, int wid, int ht, int el);
int subwipebg_rgb(unsigned char *abuf, unsigned char *bbuf, unsigned char *cbuf, int wid, int ht);


#ifndef N
#define N   (200)
#endif

#define BS (640*480*4+4)

main()
{
    int i, k;
    struct timeval tbegin, tend;
    unsigned char a[BS], b[BS], c[BS];

    srand48(1027);

    memset(a, 0, BS);
    for(i=0;i<BS/10;i++) {
        k = lrand48()%BS;
        a[k] = lrand48()%256;
    }
    memcpy(b, a, BS);
    for(i=0;i<BS/10;i++) {
        k = lrand48()%BS;
        b[k] = lrand48()%256;
    }

    gettimeofday(&tbegin, NULL);
    for(i=0;i<N;i++) {
        subwipebg_rgb(a, b, c, 160, 120);
    }
    gettimeofday(&tend, NULL);
    fprintf(stdout, "%d time, take %d ms -> ave %.3f ms\n",
        N, SUB_TIME(tend, tbegin), ((double)SUB_TIME(tend, tbegin))/N);
}
