#!/usr/bin/perl
#
# dummy resource manager
#		by k-chinen@is.aist-nara.ac.jp, 2003
#
#	Resource manager is a kind of database.
#   The program holds a host(node) list and their status.
#   Via network, the program serves such information.
#	For futher more information, please contact Mr. Arikawa.
#
#	Then, this program replys node information like as resource manager.
#
#
require 'getopts.pl';

&Getopts("hp:l:");
if($opt_p) {
    $lport = $opt_p;
}
else {
    $lport = 2236;
}
if($opt_l) {
    $hlname = $opt_l;
}
else {
    $hlname = "hostlist";
}

if($opt_h) {
    print <<EOM;
$0 - Dummy Resource Manager by k-chinen\@is.aist-nara.ac.jp, 2003
  Use this program when you lost your resource manager (RM).
  This program reply hostnames as candidates for nodes.
  The load reply is *not* true because it do not know loads of them.

usage:
    % $0 [options]

option:
    -p num      listen port number (current $lport, default 2236)
    -l file     hostname list file (current $hlname, default "hostlist")

EOM
    exit 0;
}


if(!-f $hlname) {
    print STDERR "hostlist file '$hlname' is not exist or not file\n";
    print STDERR "exit now!\n";
    exit 4;
}

open(HL, "<$hlname") || die "fail open for hostlist file : $!";
$c = 0;
while(<HL>){
    if(/^#/) {
        next;
    }
    chomp;
    if(/^\s*$/) {
        next;
    }
    @hf = split;
if(0) {
    if(defined $mark{$hf[0]}) {
    }
    else {
        push(@allhost, $hf[0]);
    }
}
else {
    push(@allhost, $hf[0]);
}
    $mark{$hf[0]}++;
    $c++;
}

close(HL);

print STDERR "got $c hosts\n";

$i = 0;
foreach $h (@allhost) {
    printf STDERR "%3d: %s\n", $i, $h;
    $i++;
}

@usehost = ();
@freehost = @allhost;

use Socket;

print STDERR "listen port $lport\n";
socket(LSOCK, PF_INET, SOCK_STREAM, getprotobyname('tcp'));
setsockopt(LSOCK, SOL_SOCKET, SO_REUSEADDR, 1);
$here_addr = sockaddr_in($lport, INADDR_ANY);
bind(LSOCK, $here_addr)
    or die "could not bind to port : $!\n";
listen(LSOCK, SOMAXCONN)
    or die "could not listen on port $server_port : $!\n";

$SIG{PIPE} = 'IGNORE';

select(STDERR);
$| = 1;

while(1) {
    select(STDERR);

    print STDERR "have <",join(" ", @allhost).">\n";
    print STDERR "use  <",join(" ", @usehost).">\n";
    print STDERR "free <",join(" ", @freehost).">\n";

    accept(CSOCK, LSOCK);
    select(CSOCK);
    $| = 1;
    chand(CSOCK);
}

close(LSOCK);

exit 0;

sub chand {
    local(*S) = @_;

    print STDERR "f# ".(fileno S)."\n";
if(0) {
    print S "100 Hello\r\n.\r\n";
}

    while(<S>) {

        chomp;
        ($cmd, @args) = split;
        $cmd =~ tr/a-z/A-Z/;
        print STDERR "cmd '$cmd'\n";

        if($cmd eq 'QUIT') {
            last;
        }
        elsif($cmd eq 'HELP') {
            print S <<EOM;
100 help of dummy resource manager\r
\r
    HELP\r
    GET num         print a list of candidate hosts\r
    STATE host-id   print stat. of the host\r
    QUIT\r
\r
thank you\r
.\r
EOM
        }
        elsif($cmd eq 'GET') {
            $nhave = $#allhost+1;
            $nuse  = $#usehost+1;
            $nfree = $#freehost+1;
            $nreq = $args[0];
            print STDERR
             "request $nreq, free $nfree, use $nuse, all $nhave\n";
            if($nreq > $nhave) {
                print S "400 too many requires\r\n";
            }
            elsif($nreq > $nfree) {
                print S "400 not enought\r\n";
            }
            elsif($nreq <= 0) {
                print S "400 ignore number\r\n";
            }
            else {
                undef @chost;
                $i = 0;
                while($i<$nreq) {
                    $h = shift @freehost;
                    push(@chost, $h);
                    push(@usehost, $h);
                    $i++;
                }
                print S "201 ".join(" ",@chost)."\r\n";
            }
        }
        elsif($cmd eq 'POST') {
            $ph = $args[0];
            print STDERR "client post '$ph'\n";
            if(defined $mark{$ph}) {
                @hv = grep /\b$ph\b/, @usehost;

                print STDERR "have? $#hv\n";
                if($#hv < 0) {
                    print S "400 why?\r\n";
                }
                else {
                    print S "200 thank\r\n";
                    $i = 0;
                    for($i=0;$i<=$#usehost;$i++) {
                        if($usehost[$i] eq $ph) {
                            splice @usehost, $i, 1;
                            push(@freehost, $ph);
                            last;
                        }
                    }
                }
            }
            else {
                print S "400 strange host\r\n";
            }
        }
        elsif($cmd eq 'STATE') {
            $ph = $args[0];
            if(defined $mark{$ph}) {
                $dv = 6000 - int(rand 1000);
                print S "201 $dv\r\n";
            }
            else {
                print S "400 strange host\r\n";
            }
        }
        else {
            print S "500 ignore command\r\n";
        }

#        last;   # XXX

        if(1) {
            print STDERR "have <",join(" ", @allhost).">\n";
            print STDERR "use  <",join(" ", @usehost).">\n";
            print STDERR "free <",join(" ", @freehost).">\n";
        }
    }

#   print STDERR "bye\r\n";
#   shutdown(S,2);
    close(S);
    
}


